GDAL-RASTER-RECLASSIFY(1)

NAME
gdal-raster-reclassify - Reclassify a raster dataset

Added in version 3.11.

SYNOPSIS

            Usage: gdal raster reclassify [OPTIONS] <INPUT> <OUTPUT>

            Reclassify values in a raster dataset

            Positional arguments:
              -i, --input <INPUT>                                      Input raster datasets [required] [not available in pipelines]
              -o, --output <OUTPUT>                                    Output raster dataset [required] [not available in pipelines]

            Common Options:
              -h, --help                                               Display help message and exit
              --json-usage                                             Display usage as JSON document and exit
              --config <KEY>=<VALUE>                                   Configuration option [may be repeated]
              -q, --quiet                                              Quiet mode (no progress bar or warning message) [not available in pipelines]

            Options:
              -f, --of, --format, --output-format <OUTPUT-FORMAT>      Output format ("GDALG" allowed) [not available in pipelines]
              --co, --creation-option <KEY>=<VALUE>                    Creation option [may be repeated] [not available in pipelines]
              --overwrite                                              Whether overwriting existing output dataset is allowed [not available in pipelines]
                                                                       Mutually exclusive with --append
              --append                                                 Append as a subdataset to existing output [not available in pipelines]
                                                                       Mutually exclusive with --overwrite
              -m, --mapping <MAPPING>                                  Reclassification mappings (or specify a @<filename> to point to a file containing mappings [required]
              --ot, --datatype, --output-data-type <OUTPUT-DATA-TYPE>  Output data type. OUTPUT-DATA-TYPE=UInt8|Int8|UInt16|Int16|UInt32|Int32|UInt64|Int64|CInt16|CInt32|Float16|Float32|Float64|CFloat32|CFloat64

            Advanced Options:
              --if, --input-format <INPUT-FORMAT>                      Input formats [may be repeated] [not available in pipelines]
              --oo, --open-option <KEY>=<VALUE>                        Open options [may be repeated] [not available in pipelines]

DESCRIPTION

gdal raster reclassify reclassifies values in an input dataset. A file (or string) specifies the mapping of input pixel values or ranges to output files.

Ranges of values can be specified using brackets:
Notation | Meaning
[a,b] | Closed interval, includes both a and b
[a,b) | Left-closed, right-open, includes a but excludes b
(a,b] | Left-open, right-closed, excludes a but includes b
(a,b) | Open interval, excludes both a and b

An example file is shown below.

            # remap land cover types
            0       = 10      # land
            [2,4]   = 20      # freshwater
            1       = 40      # ocean
            (4,6]   = 50      # forest (excludes 4, includes 5 and 6)
            NO_DATA = NO_DATA # leave NoData pixels unmodified

The # character indicates a comment that is ignored by the parser but can make the file easier to read.) In this case:

    •   input values of 0 will be output as 10

    •   input values between 2 and 4 (inclusive) will be output as 20

    •   input values of 1 will be output as 40

    •   input values between 5 and 6 will be output as 50 (4 is excluded)

    •   NoData values will be preserved as NoData

The presence of any other values in the input will cause an error. If this is not desired, the input range DEFAULT can be used to specify an output value for pixels not covered by any other input range. These pixels may be converted unto NoData (DEFAULT = NO_DATA), some other constant value (e.g., DEFAULT = 50), or left unmodified (DEFAULT = PASS_THROUGH).
        [image] Raster dataset before (left) and after (right) reclassification with gdal raster reclassify --mapping "[1,3]= 101; [4, 5)= 102; 7=102; NO_DATA=103; DEFAULT=NO_DATA"..UNINDENT

    NOTE:
            gdal raster reclassify supports writing to VRT format; however, VRT files generated in this way can only be opened using GDAL 3.11 or greater.

GDALG OUTPUT (ON-THE-FLY / STREAMED DATASET)

This program supports serializing the command line as a JSON file using the GDALG output format. The resulting file can then be opened as a raster dataset using the GDALG: GDAL Streamed Algorithm driver, and apply the specified pipeline in a on-the-fly / streamed way.

PROGRAM-SPECIFIC OPTIONS

    -m, --mapping <MAPPING>
        A definition of mappings between input and output pixel values, as described above. The mappings may either be provided as text (with each entry separate by a semicolon), or they may be read from a file using @filename.txt.

STANDARD OPTIONS

    --append
        Append input raster as a new subdataset to an existing output file. Only works with drivers that support adding subdatasets such as GTiff -- GeoTIFF File Format and GPKG -- GeoPackage raster This also creates the output dataset if it does not exist yet.

    --co, --creation-option <NAME>=<VALUE>
        Many formats have one or more optional creation options that can be used to control particulars about the file created. For instance, the GeoTIFF driver supports creation options to control compression, and whether the file should be tiled.

        May be repeated.

        The creation options available vary by format driver, and some simple formats have no creation options at all. A list of options supported for a format can be listed with the --formats command line option but the documentation for the format is the definitive source of information on driver creation options. See Raster drivers format specific documentation for legal creation options for each format.

    --if, --input-format <format>
        Format/driver name to be attempted to open the input file(s). It is generally not necessary to specify it, but it can be used to skip automatic driver detection, when it fails to select the appropriate driver. This option can be repeated several times to specify several candidate drivers. Note that it does not force those drivers to open the dataset. In particular, some drivers have requirements on file extensions.

        May be repeated.

    --oo, --open-option <NAME>=<VALUE>
        Dataset open option (format specific).

        May be repeated.

    -f, --of, --format, --output-format <OUTPUT-FORMAT>
        Which output raster format to use. Allowed values may be given by gdal --formats | grep raster | grep rw | sort

    --ot, --datatype, --output-data-type <OUTPUT-DATA-TYPE>
        Output data type among Byte, Int8, UInt16, Int16, UInt32, Int32, UInt64, Int64, CInt16, CInt32, Float32, Float64, CFloat32, CFloat64.

    --overwrite
        Allow program to overwrite existing target file or dataset. Otherwise, by default, gdal errors out if the target file or dataset already exists.

RETURN STATUS CODE

The program returns status code 0 in case of success, and non-zero in case of error (non-blocking errors emitted as warnings are considered as a successful execution).

EXAMPLES

  Example 1

            $ gdal raster reclassify -m "0=10; [2,4]=20; 1=40" -i wbm.tif -o typ.tif

AUTHOR
Dan Baston <dbaston@gmail.com>

COPYRIGHT
1998-2026